     DIM ver$(18)

'------------------------------------------------------------------------------
' FTP_USB : FTP uploader, USB recorder, FTP Recorder Barix 2006
' V00.01 14.02.07 PK - NTP receive bug fixed
'                    - system time stored into RTC (if available)
' V00.02 05.03.07 PK - version info added
' V00.03 03.08.07 PK - fixed incorrect if <string expression>
' V00.04 26.11.07 PK - obsolete PRINT command replaced with DELETE
' V00.05 10.01.08 PK - implemented ABCL v0.12 IO map; button 0 (I0) now used
'                      instead of I1 to be compatible with Ann1000
' V00.06 05.11.08 AK - direct record to both FTP and USB together
' V00.07 25.12.08 AK - fixed incorrect USB READ during upload
' V00.08 16.07.09 AK - oem project for Giacomo (Turin)
' V00.09 26.09.09 AK - oem project for Giacomo (Turin), fix USB delete problem
' V00.10 09.12.09 AK - oem project for Giacomo (Turin), changed LED indication
' V01.10 30.12.10 JP - released with BCL 1.5.
' V01.11 22.11.13 SG - fixed DNS bug
'		       added start/stop functionality for input 0 again (CTS also working)
' V01.12 22.01.15 SG - changed audio format in section 1175 (FTP recording for Annuncicom to Mono)
'                    - fixed digital input trigger for Instreamer
' V01.13 12.04.21 SG - added mono/stereo stream selection even for USB recording and broadcast
' V01.14 14.03.22 SG - adding new firmware and new drivers
'------------------------------------------------------------------------------

     ver$="V1.14 14.03.2022"

     syslog "FTP_USB: audio recorder with USB and FTP storage, "+ver$


     DIM _M_r$(5000)       	'buffer for record, send, reply
     DIM ftp_v$(500)       	'terminal view to WEB
     DIM ftp_w$(500)       	'state view to WEB
     DIM ftp_c$(5),ftp_s$  	'input chars & string
     DIM ftp_f$(5)         	'flag for actions
     DIM ftp_i$(10)        	'source and flag for input mode
     DIM usb_n$(13)        	'USB new name of file from FTP
     DIM ftp_t,ftp_x,ftp_y,ftp_l,ip_1,ip_2,ip_3,ip_4,pt_1,pt_2,tmout,tout,HW   'temporary vars
     DIM tmp_s$,tmp_n$     	'temporary buffers
     DIM sel_inp	   	'temproary marker for selected input

     DIM IP$(51),ntp$(51),user$(21),pswd$(26),dir$(64),txtf$(13),set$,cmd$(64),dt$(16),_Ms$(1500),own_name$(17)
     DIM upldt$(6),upldp,utime,_DTS_,vol,inp,enc,qlt,mcg,adg,t_sck$(36),u_sck$(36),u_sck(1,1)

     'example data:
     IP$   = "192.168.2.53" 	'FTP server IP
     user$ = "anonymous"    	'FTP login name
     pswd$ = "a@a"          	'FTP password
     dir$  = "SonicIP"      	'FTP directory
     txtf$ = "playlist.m3u" 	'text file for comparing update
     upldp = 0              	'min, time for FTP-USB upload (0 - direct FTP/USB record, -1 - disable upload)
     tout = 500             	'possible FTP timeout

     sel_inp=0
     HW=iostate(60000)

 OPEN "STP:200"   as 2 : read 2,set$ : close 2
 own_name$   = mid$(set$,6,16)          	'syslog "Own name  : "+own_name$       'Own name for ICgraph discovery

     'setup
     open "STP:500"   as 2 : read 2,set$ : close 2
     vol   = midget(set$,1,1)                   'syslog "vol :"+str$(vol) 'volume
     adg   = midget(set$,2,1)                   'syslog "adg :"+str$(adg) 'AD gain
     mcg   = midget(set$,3,1)                   'syslog "mcg :"+str$(mcg) 'mic gain
     inp   = midget(set$,11,1)-128              'syslog "inp :"+str$(inp) '(129=line, 130=mic)
     enc   = midget(set$,12,1)                  'syslog "enc :"+str$(enc) 'encoding
     if enc>5 then enc=3    ' default encoding is MPEG1/48kHz
     qlt   = midget(set$,13,1)                  'syslog "qlt :"+str$(qlt) 'quality
     tsh   = midget(set$,51,1)                  'syslog "tsh :"+str$(tsh) 'time shift
     if tsh > 127 then tsh = tsh - 256

     NTP$  = mid$(set$,52,50)           	'syslog "NTP :"+NTP$      'NTP
     IP$   = mid$(set$,102,50)          	'syslog "IP  :"+IP$       'dst IP
     user$ = mid$(set$,152,20)          	'syslog "user:"+user$     'user ID
     pswd$ = mid$(set$,172,25)          	'syslog "pass:"+pswd$     'password
     open "STP:600"   as 2 : read 2,set$ : close 2
     dir$   = mid$(set$,97,63)          	'syslog "dir :"+dir$	  'FTP path
     upldt$ = mid$(set$,161,5)          	'syslog "upldt:"+upldt$   'upload time
     t_sck$ = mid$(set$,167,33)         	'dest TCP socket
     u_sck$ = mid$(set$,201,33)         	'dest UDP socket

     j = instr(1,u_sck$,":")
     u_sck(0,0) = RESOLVE(mid$(u_sck$,1,j-1))
     u_sck(0,1) = val(mid$(u_sck$,j+1,len(u_sck$)-j))

     OPEN "UDP:0.0.0.0:12301" AS 6     	'for udp commands, audio stream & NTP requests
     gosub 1210                         'set NTP time
     utime = _DTS_                      'start time for upload

     if upldt$ = "" then
        upldp = -1                                        'upload is disabled
     else
     if instr(1,upldt$,":")=3 then                        'upload by daytime "hh:mm"
        upldp = 1440                                      'day in minutes
        dtime = (val(mid$(upldt$,1,2))*60+val(mid$(upldt$,4,2)))*60 'syslog "dt>"+str$(dtime) 'daytime in seconds
        nowdt = _DTS_ % 86400                             'syslog "nw>"+str$(nowdt)'current daytime in seconds
        utime = _DTS_-nowdt+dtime : if nowdt < dtime then utime = utime-86400
     else
        upldp = val(upldt$)                               'upload by period (minutes)
     endif : endif                                        'syslog "ut>"+sprintf$("%17t",utime)

     OPEN "COM:9600,N,8,1,NON:1"    AS 2 : WRITE 2,"\r\n",0 'for terminal commands
     gosub 1110                                             'check USB

     syslog "first upld "+sprintf$("%17t",utime+upldp*60)
     ON TIMER1 gosub 1200 : TIMER 1,100      'check input each 100 ms
     '''ON TIMER2 gosub 1210 : TIMER 2,36000000 'check NTP each 10 hr

1000 WRITE 2,"ftp> ",0 : ftp_s$ = "" : ftp_i$ = "" : cmd$ = "" 'prompt for new command
1001 if ftp_i$ = "" then delay 100 : goto 1001    'check inputs

     WRITE 2,"\r\n",0
     if len(ftp_v$) < 498 then ftp_v$=ftp_v$+"\r\n" else ftp_v$=""
     syslog "<<< "+ftp_s$
     if UCASE$(mid$(ftp_s$,1,5)) = "OPEN " then gosub 1010 : goto 1003 'open FTP
     if UCASE$(ftp_s$)           = "CLOSE" then gosub 1020 : goto 1000 'close FTP
     if UCASE$(mid$(ftp_s$,1,4)) = "LIST"  then gosub 1030 : goto 1000 'get FTP dir
     if UCASE$(mid$(ftp_s$,1,4)) = "NLST"  then gosub 1030 : goto 1000 'get FTP ls
     if UCASE$(mid$(ftp_s$,1,5)) = "RETR " then gosub 1040 : goto 1000 'get file from server
     if UCASE$(mid$(ftp_s$,1,5)) = "STOR " then gosub 1050 : goto 1000 'send file to server
     if UCASE$(mid$(ftp_s$,1,5)) = "UTXT " then gosub 1100 : goto 1000 'get existing USB text file
     if UCASE$(ftp_s$)           = "ULST"  then gosub 1110 : goto 1000 'get USB directory
     if UCASE$(mid$(ftp_s$,1,5)) = "UDEL " then gosub 1120 : goto 1000 'delete USB file
     if UCASE$(mid$(ftp_s$,1,5)) = "PLAY " then gosub 1140 : goto 1000 'play USB mp3 file
     if UCASE$(mid$(ftp_s$,1,5)) = "UREC " then gosub 1150 : goto 1000 'record USB mp3 file
     if UCASE$(ftp_s$)           = "BCST"  then gosub 1155 : goto 1000 'broadcast
     if UCASE$(ftp_s$)           = "UPLD"  then gosub 1160 : goto 1000 'upload USB directory
     if UCASE$(mid$(ftp_s$,1,5)) = "FREC " then gosub 1170 : goto 1000 'record FTP mp3 file
     if UCASE$(ftp_s$)           = "QUIT"  then              goto 1004 'quit & end of program
     gosub 1005 	'else, many other usual FTP commands directly from FTP server,
               		'for example USER, PASS, CWD, DELE, HELP, SYST, STAT, etc.(see ftp HELP)

1003 gosub 1015 : goto 1000 'get reply from FTP server
1004 CLOSE 2 : CLOSE 6
     END
'------------------------------------------------------------------------------
1210 	'check NTP each 100 hr
'------------------------------------------------------------------------------
     TIMER 1,0 : n_err = 0                       'drop flag
     midset ntp_r$,1,1,&H1B                      'set NTP request
     write 6,ntp_r$,48,NTP$,123                  'send NTP request
     delay 500                                   'wait for NTP reply
     if lastlen(6)>=0 then n_err = 1 : goto 1219 'no data received -> return
     read 6,ntp_a$                               'get NTP reply

     ntpt = midget(ntp_a$,41,-4)-2208988800+tsh*1800 'local time
     syslog "NTP response received, current time "+sprintf$("%17t",_DTS_)+", server sent "+sprintf$("%17t",ntpt)
     syslog "adjusting local time"
     _DTS_=0 : delay 10 : _DTS_=ntpt
     syslog "system time is now: "+sprintf$("%17t",_DTS_)
1219 TIMER 1,100
     if n_err = 0 then msg$ = "NTP OK "    : gosub 1220
     if n_err = 1 then msg$ = "NTP error " : gosub 1220
     return
'------------------------------------------------------------------------------
1220 	'send message
'------------------------------------------------------------------------------
     if rport then write 6,msg$,0,rhost$,rport
     syslog ">>> " + msg$
     return
'------------------------------------------------------------------------------
1230 	'send BOOT messages
'------------------------------------------------------------------------------
     if recfl = 1 then msg$ = "startooo USB record on "+dir$+" "  : gosub 1220 : tcpos = -1
     if bcstf = 1 then msg$ = "start BCST stream on "+dir$+" " : gosub 1220
     if ftpfl = 1 then msg$ = "start FTP upload on bk"+dir$+" "  : gosub 1220
     if n_err = 0 then msg$ = "NTP OK " : gosub 1220
     if n_err = 1 then msg$ = "NTP error "  : gosub 1220
     if u_err = 0 then msg$ = "USB OK : Size "+str$(fsize/1024)+" kB " : gosub 1220
     if u_err = 1 then msg$ = "USB absent " : gosub 1220
     if u_err = 2 then msg$ = "USB error "  : gosub 1220
     if u_err = 3 then msg$ = "USB full : Size "+str$(fsize/1024)+" kB " : gosub 1220
     if fsize > 1610612736 then msg$ = "USB warning " : gosub 1220 'warning 1.5 GB
    'if tcp_s = 0 then msg$ = "TCP absent " : gosub 1220
    'if tcp_s = 1 then msg$ = "TCP error "  : gosub 1220
    'if tcp_s = 2 then msg$ = "TCP OK " : gosub 1220
     if f_err = 0 then msg$ = "FTP OK " : gosub 1220
     if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220
     return
'------------------------------------------------------------------------------
1200 	'check input each 100 ms
'------------------------------------------------------------------------------
     DT$ = sprintf$("%17t",_DTS_) 		'get current date&time
     if ftp_i$ = "" then
        ftp_w$ = "idle"
        if mediatype(5) then close 5
        if or(n_err,u_err,f_err) then
           led = led+1
           'if n_err then if led%2 >= 1 then ioctl 200,1 else ioctl 200,0
           'if u_err then if led%4 >= 2 then ioctl 200,1 else ioctl 200,0
           'if f_err then if led%6 >= 3 then ioctl 200,1 else ioctl 200,0
           if led%4 >= 2 then ioctl 200,1 else ioctl 200,0 	'changed LED indication
        else
           led = 0 : ioctl 200,1 		'LED ON -- all OK
        endif
     else
        if recfl then led = led+1 : if led%20 >= 10 then ioctl 200,1 else ioctl 200,0
        'if bcstf then led = led+1 : if led%20 >=  2 then ioctl 200,1 else ioctl 200,0
        if bcstf then led = led+1 : if led%20 >= 10 then ioctl 200,1 else ioctl 200,0 	'changed LED indication
     endif

     READ 2,ftp_c$ : if ftp_i$ then if ftp_c$ then ftp_i$ = "" : return 'stop by any key
     WRITE 2,ftp_c$,0 'read & return char to terminal before CR
     if mid$(ftp_c$,1,1)<>"\r" then
        ftp_s$=ftp_s$+ftp_c$
     else
        ftp_i$ = "terminal"
           ftp_w$ = ftp_s$+" by "+ftp_i$+": "+DT$
           ftp_v$ = "ftp> "+ftp_s$+" by "+ftp_i$+": "+DT$
        return
     endif

     L=lastlen(6)
     if L<0 then
        rhost$ = rmthost$(6)			'IP of active remote side
        rport  = rmtport(6)			'port of active remote side
        read 6,_Ms$
        if _Ms$ = "c=65535" then		'broadcast DISCOVER
           write 6,"<ANNUNCICOMIC><NAME>"+own_name$+"</NAME></ANNUNCICOMIC> ",0,rhost$,rport
           if boot = 0 then boot = 1 : gosub 1230 'send BOOT messages
        else
           cmd$ = _Ms$ : _Ms$ = ""    		'check old UDP command for idle state
           if cmd$ = "BOOT" then cmd$ = "" : gosub 1230 'send BOOT messages
        endif
     endif

     if ftp_i$ = "" then 'start conditions
        if AND(or(iostate(201)=0,iostate(201)=2),iostate(60004)>0) then ftp_i$ = "button" : sel_inp=1 '0,if button1 is pressed
        if iostate(300) then ftp_i$ = "button+": sel_inp=2 			'if CTS is clicked down -- start record
        if cmd$ = "start" then ftp_i$ = "udp/web" : cmd$ = "" : sel_inp=2 	'for WEB and UDP
	if ftp_i$ <> "" then
           if upldp then tmp_s$ = "UREC " else tmp_s$ = "FREC " 'record mode (to USB or FTP)
           ftp_s$ = tmp_s$ + mid$(DT$,3,8) + ".mp3" 	'file name: MMDDhhmm.mp3
           WRITE 2," ...\r\nftp> "+ftp_s$+"\r\n",0  	'print prompt
           ftp_w$ = ftp_s$+" by "+ftp_i$+": "+DT$
           ftp_v$ = "ftp> "+ftp_s$+" by "+ftp_i$+": "+DT$
           return
	endif
     else 					'stop conditions
	IF sel_inp=1 THEN
        if ftp_i$ = "button" then if and(iostate(201)<>0,iostate(201)<>2) then ftp_i$ = "" : sel_inp=0 : return '1, if button1 is released
	ENDIF
	IF sel_inp=2 THEN
	   if ftp_i$ = "button+" then if iostate(300)=0 then ftp_i$ = "button"  : return 'if CTS is clicked up 
           if ftp_i$ = "udp/web" then if iostate(300)   then ftp_i$ = "button-" : return 'if CTS is clicked down -- to stop broadcast by button
           if ftp_i$ = "button"  then if iostate(300)   then ftp_i$ = "button-" : return 'if CTS is clicked down 
           if ftp_i$ = "button-" then if iostate(300)=0 then ftp_i$ = "" : sel_inp=0 : return 'if CTS is clicked up -- finish record 
	ENDIF
        if cmd$ = "stop" then ftp_i$ = "" : cmd$ = "" : sel_inp=0 : led = 0 return 	 'for WEB and UDP
     endif

     if ftp_i$ = "" then 			'other commands are possible only while idle
        if cmd$ <> "" then
           ftp_s$ = cmd$ : cmd$ = "" : ftp_i$ = "udp/web"
           ftp_w$ = ftp_s$+" by "+ftp_i$+": "+DT$
           ftp_v$ = "ftp> "+ftp_s$+" by "+ftp_i$+": "+DT$
           ioctl 200,0 'LED OFF
           return
        endif

        if and(upldp <> -1, upldp <> 0) then 	'upload by period
           if _DTS_ > utime+upldp*60 then
              utime = _DTS_ : ftp_s$ = "upld" : ftp_i$ = "timer"
              syslog "next upld "+sprintf$("%17t",utime+upldp*60)
              ftp_w$ = ftp_s$+" by "+ftp_i$+": "+DT$
              ftp_v$ = "ftp> "+ftp_s$+" by "+ftp_i$+": "+DT$
              ioctl 200,0 'LED OFF
              return
           endif
        endif
     endif
     return
'------------------------------------------------------------------------------
1100 	'get existing USB text file
'------------------------------------------------------------------------------
     OPEN "C_R:usb:///"+mid$(ftp_s$,6) as 4
     if mediatype(4) = 0 then return
1101 read 4,tmp_s$
     if len(tmp_s$)>0 then
        WRITE 2,tmp_s$+"\r\n",0
        if len(ftp_v$)+len(tmp_s$) < 498 then ftp_v$=ftp_v$+tmp_s$+"\r\n" else ftp_v$=tmp_s$+"\r\n"
        goto 1101
     endif
     close 4
     return
'------------------------------------------------------------------------------
1110 	'get USB directory
'------------------------------------------------------------------------------
     TIMER 1,0 : fsize = 0 : if u_err <> 3 then u_err = 0
     OPEN "C_R:usb:///" as 4
     if mediatype(4) = 0 then u_err = 1 : goto 1119 	'USB absent
1111 read 4,tmp_s$
     if len(tmp_s$)>0 then
        if midget(tmp_s$,14,1)=2 then
           tmp_s$ = tmp_s$+ " (DIR)"
        else
		OPEN "C_R:usb:///"+tmp_s$ as 1
           if mediatype(1) = 0 then u_err = 2 : goto 1112
           fsize = fsize + filesize(1)
           tmp_s$ = tmp_s$+ " " + str$(filesize(1))
           close 1
1112    endif
        WRITE 2,tmp_s$+"\r\n",0
        if len(ftp_v$)+len(tmp_s$) < 498 then ftp_v$=ftp_v$+tmp_s$+"\r\n" else ftp_v$=tmp_s$+"\r\n"
        goto 1111
     endif
1119 if mediatype(4) then close 4
     if u_err = 0 then msg$ = "USB OK : Size "+str$(fsize/1024)+" kB " : gosub 1220
     if u_err = 1 then msg$ = "USB absent " : gosub 1220
     if u_err = 2 then msg$ = "USB error " : gosub 1220
     if u_err = 3 then msg$ = "USB full : Size "+str$(fsize/1024)+" kB " : gosub 1220
     if fsize > 1610612736 then msg$ = "USB warning " : gosub 1220  	'warning 1.5 GB
     TIMER 1,100
     return
'------------------------------------------------------------------------------
1120 	'delete USB file
'------------------------------------------------------------------------------
     DELETE "usb:///"+mid$(ftp_s$,6)
     return
'------------------------------------------------------------------------------
1140 	'play USB file
'------------------------------------------------------------------------------
     OPEN "C_R:usb:///"+mid$(ftp_s$,6) as 4
     if mediatype(4) = 0 then return
     write 2," ...press any key to stop USB playing!\r\n",0

     Open "AUD:1,6,0,4000" as 7				'output: MP3 play
     Write 7,str$(vol),-12              		'set Volume (*5%)
     ftp_c$ = ""

1141 read 2,ftp_c$ : if ftp_c$ <> "" then goto 1149 	'stop by any key
     read 4,_M_r$ : ftp_l = lastlen(4)			'syslog ">>>"+str$(ftp_l)
1143 if filesize(7)<ftp_l then goto 1143
     if ftp_l>0 then write 7,_M_r$,ftp_l : if ftp_i$ <> "" then goto 1141 'add to play buffer

1142 if filesize(7)<30000 then goto 1142		'play end of mp3
     delay 1000

1149 close 7
     close 4
     return
'------------------------------------------------------------------------------
1150 	'record USB file
'------------------------------------------------------------------------------
     recfl = 1 : msg$ = "start USB record on "+dir$+" " : gosub 1220
    'tcp_s = 0 : tcpos = -1 : wait = 0 'TCP status

     OPEN "C_W:usb:///"+mid$(ftp_s$,6) as 4
     if mediatype(4) = 0 then u_err = 2 : msg$ = "USB error ("+str$(fsize)+" B) on "+dir$+" " : gosub 1220

     write 2," ...press any key to stop USB recording!\r\n",0

    IF OR(inp=2,HW=7,HW=13,HW=20) THEN
		Open "AUD:2,0,"+str$(2048+1024+qlt*16+enc) as 7	'mp3 encoding mono , changed by SG !
		ELSE
                Open "AUD:2,0,"+str$(1024+qlt*16+enc) as 7	'mp3 encoding stereo , changed by SG !
	ENDIF
     Write 7,str$(mcg),-1                                'set MIC Gain
     Write 7,str$(adg),-2                                'set A/D Gain
     Write 7,str$(inp),-3                                'set input source (1-line,2-microphone)
     Write 7,str$(vol),-12                               'set Volume (*5%)
     ftp_c$ = ""

1151 read 7,_M_r$,1400 : ftp_l = lastlen(7)              'NB!!! _M_r$ must be > max len
     if ftp_l>0 then
        if mediatype(4) then write 4,_M_r$,ftp_l         'add to USB file
        if lastlen(4)<0 then if u_err <> 3 then u_err = 3 : msg$ = "USB full on "+dir$+" " : gosub 1220
        if u_sck$ then write 6,_M_r$,ftp_l,u_sck         'send to udp socket
        if t_sck$ then
           if mediatype(5)=0 then
              open "TCN:"+t_sck$ as 5 : syslog "TCN opened"
           else
              if connected(5) then
                 write 5,_M_r$,ftp_l : tcp_s = 2 : wait = 0
              else
                 tcp_s = 1 : wait = wait + 1 : syslog "TCN waiting..."+str$(wait)
              endif
              if wait > 99 then wait = 0 : close 5,1 : syslog "TCN closed" 'NB! close without waiting
           endif
        endif
        if tcpos <> tcp_s then
           if tcp_s = 0 then msg$ = "TCP absent " : gosub 1220
           if tcp_s = 1 then msg$ = "TCP error " : gosub 1220
           if tcp_s = 2 then msg$ = "TCP OK " : gosub 1220
           tcpos = tcp_s
        endif
        syslog ">"+str$(ftp_l)
     endif
     if ftp_i$ <> "" then goto 1151                      'check stop

     if mediatype(7) then close 7
     if mediatype(4) then close 4
     recfl = 0 : msg$ = "stop USB record on "+dir$+" " : gosub 1220
     gosub 1110                                          'check USB disk
     return
'------------------------------------------------------------------------------
1155 	'broadcast
'------------------------------------------------------------------------------
syslog "1155"
     bcstf = 1 : msg$ = "start BCST stream on "+dir$+" " : gosub 1220

IF OR(inp=2,HW=7,HW=13,HW=20) THEN
     Open "AUD:2,0,"+str$(2048+1024+qlt*16+enc) as 7	'mp3 encoding mono , changed by SG !
	ELSE
                Open "AUD:2,0,"+str$(1024+qlt*16+enc) as 7	'mp3 encoding stereo , changed by SG !
ENDIF
     Write 7,str$(mcg),-1                                'set MIC Gain
     Write 7,str$(adg),-2                                'set A/D Gain
     Write 7,str$(inp),-3                                'set input source (1-line,2-microphone)
     Write 7,str$(vol),-12                               'set Volume (*5%)
     ftp_c$ = ""

1156 read 7,_M_r$,1400 : ftp_l = lastlen(7)              'NB!!! _M_r$ must be > max len
     if ftp_l>0 then
        if u_sck$ then write 6,_M_r$,ftp_l,u_sck         'send to udp socket
     endif
     if ftp_i$ <> "" then goto 1156                      'check stop

     if mediatype(7) then close 7
     bcstf = 0 : msg$ = "stop BCST stream on "+dir$+" " : gosub 1220
	 syslog "1155"
     return
'------------------------------------------------------------------------------
1160 	'upload USB directory
'------------------------------------------------------------------------------
     OPEN "C_R:usb:///" as 4
     if mediatype(4) = 0 then u_err = 1 : msg$ = "USB absent on "+dir$+" " : gosub 1220 : goto 1168

     f_err = 0 'drop flag
     ftpfl = 1 : msg$ = "start FTP upload on bk"+dir$+" " : gosub 1220

     'a) open FTP connection to a server using provided IP of server, userid, password, directory

     ftp_s$ = "open "+IP$   : gosub 1010 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ = "user "+user$ : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ = "pass "+pswd$ : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ =  "cwd bk"+dir$  : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169

     'b) get USB directory, upload to FTP, delete USB

1161 read 4,tmp_s$
     if len(tmp_s$)>0 then
        if midget(tmp_s$,14,1)=2 then goto 1161 	'miss dir
        WRITE 2,">>> "+tmp_s$+"\r\n",0 			'print file name
        if len(ftp_v$)+len(tmp_s$) < 494 then		'print to WEB too
           ftp_v$=ftp_v$+">>> "+tmp_s$+"\r\n"
        else
           ftp_v$=">>> "+tmp_s$+"\r\n"
        endif
        ftp_s$ = "stor "+tmp_s$ : gosub 1050		'send file to server
        if f_err then goto 1169 			'break by FTP error
        DELETE "usb:///"+tmp_s$ 			'delete file
        goto 1161
     endif

1169 if mediatype(1) then close 1
     ftpfl = 0 : msg$ = "stop FTP upload on "+dir$+" " : gosub 1220
   '  if f_err = 0 then u_err = 0 : msg$ = "FTP OK " : gosub 1220  'also drop USB full
    ' if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220

1168 if mediatype(4) then close 4
     gosub 1110 'check USB disk
     gosub 1210 'check NTP time
     return
'------------------------------------------------------------------------------
1170 	'record FTP file
'------------------------------------------------------------------------------
     f_err = 0 'drop flag
     tmp_n$ = mid$(ftp_s$,6) 				'remember file name

     'a) open FTP connection to a server using provided IP of server, userid, password, directory

if f_err = 0 then msg$ = "FTP OK " : gosub 1220

	 '	read 8,_M_r$,1400 : ftp_l = lastlen(8)	'NB!!! _M_r$ must be > max len
     'if ftp_l>0 then
     '   if u_sck$ then write 6,_M_r$,ftp_l,u_sck	'send to udp socket
     'endif

	 	 
     ftp_s$ = "open "+IP$   : gosub 1010 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ = "user "+user$ : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ = "pass "+pswd$ : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     ftp_s$ =  "cwd "+dir$  : gosub 1005 : gosub 1015 : if f_err > 0 then msg$ = "FTP error "+str$(f_err)+" on "+dir$+" " : gosub 1220 ': if f_err then goto 1169
     if mediatype(1) = 0 then ftp_s$ = "UREC "+tmp_n$ : gosub 1150 : return 	'if FTP fail, try to use USB at least
     write 2," ...press any key to stop FTP/USB recording!\r\n",0

     'b) open FTP file
     if CONNECTED(1) then
        WRITE 1,"TYPE I\r\n",0  : gosub 1015
        WRITE 1,"PASV\r\n",0            : ftp_f$ = "ippt" : gosub 1015 : ftp_f$ = ""
        WRITE 1,"STOR "+tmp_n$+"\r\n",0 : ftp_f$ = "ftpf" : gosub 1015 : ftp_f$ = ""
        WRITE 1,"TYPE A\r\n",0  : gosub 1015
        if mediatype(0) then CLOSE 0
     endif

     if mediatype(1) then close 1
     return
'------------------------------------------------------------------------------
1175 	'store record file
'------------------------------------------------------------------------------
     'c) open audio and record to FTP
     OPEN "C_W:usb:///"+tmp_n$ as 4
recfl = 1 : msg$ = "start USB record on "+dir$+" " : gosub 1220
IF OR(inp=2,HW=7,HW=13,HW=20) THEN
     Open "AUD:2,0,"+str$(2048+1024+qlt*16+enc) as 7	'mp3 encoding mono , changed by SG !
	ELSE
                Open "AUD:2,0,"+str$(1024+qlt*16+enc) as 7	'mp3 encoding stereo , changed by SG !
ENDIF
     Write 7,str$(mcg),-1				'set MIC Gain
     Write 7,str$(adg),-2				'set A/D Gain
     Write 7,str$(inp),-3 				'set input source (1-line,2-microphone)
     Write 7,str$(vol),-12 				'set Volume (*5%)
     ftp_c$ = ""
	 
1171 read 7,_M_r$,1400 : ftp_l = lastlen(7)		'NB!!! _M_r$ must be > max len
    
	if ftp_l>0 then
	        if mediatype(4) then write 4,_M_r$,ftp_l	'add to USB file
        if lastlen(4)<0 then if u_err <> 3 then u_err = 3 : msg$ = "USB full on "+dir$+" " : gosub 1220
		if CONNECTED(0) then WRITE 0,_M_r$,ftp_l 	'add to FTP file
        if u_sck$ then write 6,_M_r$,ftp_l,u_sck         	'send to udp socket
	endif
	
	
	
    'if ftp_l>0 then if CONNECTED(0) then WRITE 0,_M_r$,ftp_l 'add to FTP file
    'if ftp_l>0 then if mediatype(4) then write 4,_M_r$,ftp_l 'add to USB file
	 
     if ftp_i$ <> "" then goto 1171                           'check stop
recfl = 0 : msg$ = "stop USB record on "+dir$+" " : gosub 1220
1179 close 7
     delay 1000 'for correct sending end of file
     if mediatype(0) then close 0
     if mediatype(4) then close 4
     return
'------------------------------------------------------------------------------
1005 	'many other usual FTP commands, for example USER, PASS, CWD, DELE, HELP, SYST, STAT, etc.
'------------------------------------------------------------------------------
     if CONNECTED(1) then WRITE 1,ftp_s$+"\r\n",0
     return
'------------------------------------------------------------------------------
1010 	'open FTP
'------------------------------------------------------------------------------
     OPEN "TCP:"+mid$(ftp_s$,6)+":21" AS 1
     return
'------------------------------------------------------------------------------
1015 	'get reply
'------------------------------------------------------------------------------
     if mediatype(1) = 0 then f_err = 8 : return
     ftp_t = _TMR_(0) : tmout = 5000

1016 READ 1,_M_r$
     if lastlen(1) then
        WRITE 2,_M_r$,0
        if len(ftp_v$)+len(_M_r$) < 500 then ftp_v$=ftp_v$+_M_r$ else ftp_v$=_M_r$
        ftp_t = _TMR_(0) : tmout = tout
        if ftp_f$ = "ippt" then if val(mid$(_M_r$,1,3))=227 then gosub 1035 else f_err = 1
        if ftp_f$ = "list" then if val(mid$(_M_r$,1,3))<200 then gosub 1023 else f_err = 2
        if ftp_f$ = "data" then if val(mid$(_M_r$,1,3))<200 then gosub 1025 else f_err = 3
        if ftp_f$ = "file" then if val(mid$(_M_r$,1,3))<200 then gosub 1045 else f_err = 4
        if ftp_f$ = "ftpf" then if val(mid$(_M_r$,1,3))<200 then gosub 1175 else f_err = 5
        if ftp_f$ = ""     then if val(mid$(_M_r$,1,3))>499 then                 f_err = 6
     endif
     if _TMR_(0) - ftp_t < tmout then if CONNECTED(1) then goto 1016

     if f_err then syslog "error reply for timeout "+str$(tout)+" ms, error status = "+str$(f_err)
     if tmout = 5000 then f_err = 7 : syslog "no reply for timeout 5000 ms, error status = "+str$(f_err)
     if CONNECTED(1) = 0 then CLOSE 1
     return
'------------------------------------------------------------------------------
1020 	'close FTP
'------------------------------------------------------------------------------
     if mediatype(1) then CLOSE 1
     return
'------------------------------------------------------------------------------
1030 	'list,nlst
'------------------------------------------------------------------------------
     if CONNECTED(1) then
        WRITE 1,"PASV\r\n",0    : ftp_f$ = "ippt" : gosub 1015 : ftp_f$ = ""
        WRITE 1,ftp_s$+"\r\n",0 : ftp_f$ = "list" : gosub 1015 : ftp_f$ = ""
        if mediatype(0) then CLOSE 0
     endif
     return
'------------------------------------------------------------------------------
1023 	'get data reply or text file to terminal
'------------------------------------------------------------------------------
     if mediatype(0) = 0 then return
     ftp_t = _TMR_(0) : tmout = 5000

1024 READ 0,_M_r$
     if lastlen(0) then
        WRITE 2,_M_r$,0
        if len(ftp_v$)+len(_M_r$) < 500 then ftp_v$=ftp_v$+_M_r$ else ftp_v$=_M_r$
        ftp_t = _TMR_(0) : tmout = tout
     endif
     if _TMR_(0) - ftp_t < tmout then if CONNECTED(0) then goto 1024

     if tmout = 5000 then syslog "no reply for timeout 5000 ms"
     if CONNECTED(0) = 0 then CLOSE 0
     return
'------------------------------------------------------------------------------
1025 	'get data reply or text file to USB file
'------------------------------------------------------------------------------
     if mediatype(0) = 0 then return
     if usb_n$ <> "" then
        OPEN "C_W:usb:///"+usb_n$ as 4         'use new name for FTP file
     else
        OPEN "C_W:usb:///"+mid$(ftp_s$,6) as 4 'use old name for FTP file
     endif
     if mediatype(4) = 0 then return
     ftp_t = _TMR_(0) : tmout = 5000

1026 READ 0,_M_r$ : ftp_l = lastlen(0)
     if ftp_l then WRITE 4,_M_r$,ftp_l : ftp_t = _TMR_(0) : tmout = tout
     if _TMR_(0) - ftp_t < tmout then if CONNECTED(0) then goto 1026

     if tmout = 5000 then syslog "no reply for timeout 5000 ms"
     CLOSE 4 : if CONNECTED(0) = 0 then CLOSE 0
     return
'------------------------------------------------------------------------------
1035 	'open data connection
'------------------------------------------------------------------------------
                     ftp_y=instr(1,    _M_r$,"(")
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,",") : ip_1=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,",") : ip_2=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,",") : ip_3=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,",") : ip_4=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,",") : pt_1=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     ftp_x=ftp_y+1 : ftp_y=instr(ftp_x,_M_r$,")") : pt_2=val(mid$(_M_r$,ftp_x,ftp_y-ftp_x))
     OPEN "TCP:"+str$(ip_1)+"."+str$(ip_2)+"."+str$(ip_3)+"."+str$(ip_4)+":"+str$(pt_1*256+pt_2) AS 0
     return
'------------------------------------------------------------------------------
1040 	'retr
'------------------------------------------------------------------------------
     if CONNECTED(1) then
        WRITE 1,"TYPE I\r\n",0  : gosub 1015
        WRITE 1,"PASV\r\n",0    : ftp_f$ = "ippt" : gosub 1015 : ftp_f$ = ""
        WRITE 1,ftp_s$+"\r\n",0 : ftp_f$ = "data" : gosub 1015 : ftp_f$ = ""
        WRITE 1,"TYPE A\r\n",0  : gosub 1015
        if mediatype(0) then CLOSE 0
     endif
     return
'------------------------------------------------------------------------------
1050 	'stor
'------------------------------------------------------------------------------
     if CONNECTED(1) then
        WRITE 1,"TYPE I\r\n",0  : gosub 1015
        WRITE 1,"PASV\r\n",0    : ftp_f$ = "ippt" : gosub 1015 : ftp_f$ = ""
        WRITE 1,ftp_s$+"\r\n",0 : ftp_f$ = "file" : gosub 1015 : ftp_f$ = ""
        WRITE 1,"TYPE A\r\n",0  : gosub 1015
        if mediatype(0) then CLOSE 0
     endif
     return
'------------------------------------------------------------------------------
1045 	'send file to remote FTP server
'------------------------------------------------------------------------------
     if mediatype(0) = 0 then return
     OPEN "C_R:usb:///"+mid$(ftp_s$,6) AS 3
1046 READ 3,_M_r$ : ftp_l = lastlen(3)
     if ftp_l>0 then if CONNECTED(0) then WRITE 0,_M_r$,ftp_l : goto 1046
     delay 1000 'for correct sending end of file
     CLOSE 3 : if mediatype(0) then CLOSE 0
     return
'------------------------------------------------------------------------------
